using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_Ejercicios_PerfilesCabecera_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(KairosProEntities _dbcontext, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            return null;
        }

        public override dynamic Obtener_Registro_PorCampo(string _str_CampoBusqueda, string _str_Filtro)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRS_Ejercicios_PerfilesCabecera g_mdl_KRS_Ejercicios_PerfilesCabecera = null;
        public KRS_Ejercicios_PerfilesCabecera Obtener_Modelo_Por_Id(long _lng_id,long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + 
                                            nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.id) + "=@id and " +
                                            nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_Ejercicios_PerfilesCabecera;
        }
        public KRS_Ejercicios_PerfilesCabecera Obtener_Modelo_Por_IdPerfilCabecera(long _lng_idPerfilCabecera, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                            nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + "=@idPerfilCabecera and " +
                                            nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPerfilCabecera",  _lng_idPerfilCabecera),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_Modelo_Por_IdPerfilCabecera), true);
            }

            return g_mdl_KRS_Ejercicios_PerfilesCabecera;
        }
        public KRS_Ejercicios_PerfilesCabecera Obtener_Modelo_Por_EjercicioEmpleadoCliente(long _lng_idEjercico, long _lng_idEmpleado, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "=@idEjercicio and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEjercicio",  _lng_idEjercico),
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente", _lng_CodigoCliente)
                };


                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_Modelo_Por_EjercicioEmpleadoCliente), true);
            }

            return g_mdl_KRS_Ejercicios_PerfilesCabecera;
        }
        public KRS_Ejercicios_PerfilesCabecera Obtener_Modelo_Por_EjercicioEmpleadoEmpresa(long _lng_idEjercico, long _lng_idEmpleado, long _lng_idEmpresa)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + 
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "=@idEjercicio and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEmpresa) + "=@idEmpresa  and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEjercicio",  _lng_idEjercico),
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@idEmpresa",  _lng_idEmpresa),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };


                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_Ejercicios_PerfilesCabecera;
        }


        #region Ejecutar_Consulta_Modelo

        private void Ejecutar_Consulta_Modelo(string _str_SQL, object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el Modelo
                g_mdl_KRS_Ejercicios_PerfilesCabecera = obj_KairosProEntities.Database.SqlQuery<KRS_Ejercicios_PerfilesCabecera>(_str_SQL, _arr_Parametros).FirstOrDefault();

               
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }
        #endregion

        #endregion

        #region Modelo Listado
        private List<KRS_Ejercicios_PerfilesCabecera> g_lst_KRS_Ejercicios_PerfilesCabecera = null;
        private GEN_EjerciciosActivos_Empresa g_mdl_GEN_EjerciciosActivos_Empresa_ModeloListado = null;

        public List<KRS_Ejercicios_PerfilesCabecera> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids, GEN_EjerciciosActivos_Empresa _mdl_GEN_EjerciciosActivos_Empresa_ModeloListado, bool _bol_Cargar_PerfilCabecera)
        {
            try
            {
                g_mdl_GEN_EjerciciosActivos_Empresa_ModeloListado = _mdl_GEN_EjerciciosActivos_Empresa_ModeloListado;

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_Ejercicios_PerfilesCabecera),
                                                                                           nameof(KRS_Ejercicios_PerfilesCabecera.id),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_Ids);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                        " WHERE " +
                                            str_Filtros_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     _bol_Cargar_PerfilCabecera);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_Ejercicios_PerfilesCabecera;
        }
        public List<KRS_Ejercicios_PerfilesCabecera> Obtener_ModeloListado_Por_IdEmpleado(long _lng_idEmpleado, GEN_EjerciciosActivos_Empresa _mdl_GEN_EjerciciosActivos_Empresa_ModeloListado, bool _bol_Cargar_PerfilCabecera)
        {
            try
            {
                g_mdl_GEN_EjerciciosActivos_Empresa_ModeloListado = _mdl_GEN_EjerciciosActivos_Empresa_ModeloListado;

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " + 
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_PerfilCabecera);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdEmpleado), true);
            }

            return g_lst_KRS_Ejercicios_PerfilesCabecera;
        }
        public List<KRS_Ejercicios_PerfilesCabecera> Obtener_ModeloListado_Por_EjercicioEmpresaEmpleadoCodigoCliente(long _lng_idEjercicio,List<long> _lst_idEmpleado,long _lng_CodigoCliente, GEN_EjerciciosActivos_Empresa _mdl_GEN_EjerciciosActivos_Empresa_ModeloListado)
        {
            try
            {
                g_mdl_GEN_EjerciciosActivos_Empresa_ModeloListado = _mdl_GEN_EjerciciosActivos_Empresa_ModeloListado;

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empleados = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_Ejercicios_PerfilesCabecera),
                                                                                          nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado),
                                                                                          G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                          _lst_idEmpleado);


                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "=@idEjercicio and " +
                                        nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente and " +
                                        str_Filtros_Empleados;

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEjercicio", _lng_idEjercicio));
                lst_Parametros.Add(new SqlParameter("@codigoCliente", _lng_CodigoCliente));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 true);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EjercicioEmpresaEmpleadoCodigoCliente), true);
            }

            return g_lst_KRS_Ejercicios_PerfilesCabecera;
        }
        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<KRS_PerfilesCabecera> g_lst_KRS_PerfilesCabecera = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros,
                                                    bool _bol_Cargar_PerfilCabecera)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRS_Ejercicios_PerfilesCabecera = obj_KairosProEntities.Database.SqlQuery<KRS_Ejercicios_PerfilesCabecera>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_KRS_Ejercicios_PerfilesCabecera != null && g_lst_KRS_Ejercicios_PerfilesCabecera.Count > 0)
                {
                    
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_PerfilCabecera)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //KRS_PerfilesCabecera #############################################
                        if (_bol_Cargar_PerfilCabecera)
                        {
                            ThreadStart obj_ThreadStart_PERFILESCABECERA = new ThreadStart(Obtener_PerfilesCabecera_Modelo_Listado);
                            Thread obj_Thread_PERFILESCABECERA = new Thread(obj_ThreadStart_PERFILESCABECERA);
                            obj_Thread_PERFILESCABECERA.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera in g_lst_KRS_Ejercicios_PerfilesCabecera)
                        {
                            //KRS_PerfilesCabecera #############################################
                            if (_bol_Cargar_PerfilCabecera &&
                                g_lst_KRS_PerfilesCabecera != null &&
                                g_lst_KRS_PerfilesCabecera.Count > 0)
                            {
                                mdl_KRS_Ejercicios_PerfilesCabecera.KRS_PerfilesCabecera = g_lst_KRS_PerfilesCabecera.Where(m => m.id == mdl_KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_PerfilesCabecera_Modelo_Listado()
        {
            try
            {
                KRS_PerfilesCabecera_Datos obj_KRS_PerfilesCabecera_Datos = new KRS_PerfilesCabecera_Datos();
                g_lst_KRS_PerfilesCabecera = obj_KRS_PerfilesCabecera_Datos.Obtener_ModeloListado_Por_Ids(g_lst_KRS_Ejercicios_PerfilesCabecera.Select(m => m.idPerfilCabecera).ToList(), g_mdl_GEN_EjerciciosActivos_Empresa_ModeloListado,true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.id) + " , " +
                    nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + " , " +
                    nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + " , " +
                    nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + " , " +
                    nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + " , " +
                    nameof(KRS_Ejercicios_PerfilesCabecera) + "." + nameof(KRS_Ejercicios_PerfilesCabecera.idEmpresa) +
                " FROM " + nameof(KRS_Ejercicios_PerfilesCabecera);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera_AGrabar = (KRS_Ejercicios_PerfilesCabecera)_mdl_obj;
                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera_DatosViejos = new KRS_Ejercicios_PerfilesCabecera();

                // Ver si existe ######################################################################
                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera_Final = Obtener_Modelo_Por_Id(mdl_KRS_Ejercicios_PerfilesCabecera_AGrabar.id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);
                //######################################################################################

                if (mdl_KRS_Ejercicios_PerfilesCabecera_Final!=null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_Ejercicios_PerfilesCabecera_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Datos viejos para la trazabilidar
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_Ejercicios_PerfilesCabecera_Final, mdl_KRS_Ejercicios_PerfilesCabecera_DatosViejos, false, false);

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_Ejercicios_PerfilesCabecera_AGrabar, mdl_KRS_Ejercicios_PerfilesCabecera_Final, false, false);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(KRS_Ejercicios_PerfilesCabecera) +
                                           " SET " +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + "=@idPerfilCabecera," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "=@idEjercicio," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "=@idEmpleado," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idEmpresa) + "=@idEmpresa" +
                                           " WHERE " +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idPerfilCabecera",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idPerfilCabecera),
                        new SqlParameter("@idEjercicio",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEjercicio),
                        new SqlParameter("@idEmpleado",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpleado),
                        new SqlParameter("@codigoCliente",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.codigoCliente),
                        mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa!=null
                            ?   new SqlParameter("@idEmpresa", mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                        new SqlParameter("@id",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.id)
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_Ejercicios_PerfilesCabecera_Final.id;
                }
                else
                {
                    mdl_KRS_Ejercicios_PerfilesCabecera_Final = new KRS_Ejercicios_PerfilesCabecera();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_Ejercicios_PerfilesCabecera_Final.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_Ejercicios_PerfilesCabecera_AGrabar, mdl_KRS_Ejercicios_PerfilesCabecera_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRS_Ejercicios_PerfilesCabecera) +
                                                " (" +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idEmpresa) + 
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(KRS_Ejercicios_PerfilesCabecera.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idPerfilCabecera," +
                                                    "@idEjercicio," +
                                                    "@idEmpleado," +
                                                    "@codigoCliente," +
                                                    "@idEmpresa" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPerfilCabecera",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idPerfilCabecera),
                        new SqlParameter("@idEjercicio",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEjercicio),
                        new SqlParameter("@idEmpleado",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpleado),
                        new SqlParameter("@codigoCliente",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.codigoCliente),
                        mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa!=null
                            ?   new SqlParameter("@idEmpresa", mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }
               
                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_Ejercicios_PerfilesCabecera), mdl_KRS_Ejercicios_PerfilesCabecera_DatosViejos, mdl_KRS_Ejercicios_PerfilesCabecera_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Grabar_Simple(KRS_Ejercicios_PerfilesCabecera _mdl_KRS_Ejercicios_PerfilesCabecera)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera_DatosViejos = new KRS_Ejercicios_PerfilesCabecera();

                // Ver si existe ######################################################################
                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera_Final = Obtener_Modelo_Por_EjercicioEmpleadoCliente( _mdl_KRS_Ejercicios_PerfilesCabecera.idEjercicio,
                                                                                                                                         _mdl_KRS_Ejercicios_PerfilesCabecera.idEmpleado,
                                                                                                                                         _mdl_KRS_Ejercicios_PerfilesCabecera.codigoCliente);
                //######################################################################################


                if (mdl_KRS_Ejercicios_PerfilesCabecera_Final!=null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    _mdl_KRS_Ejercicios_PerfilesCabecera.id = mdl_KRS_Ejercicios_PerfilesCabecera_Final.id;

                    // Validado el codigo del cliente, se lo asignamos antes de grabar
                    _mdl_KRS_Ejercicios_PerfilesCabecera.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Datos viejos para la trazabilidar
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_Ejercicios_PerfilesCabecera_Final, mdl_KRS_Ejercicios_PerfilesCabecera_DatosViejos, false, false);
                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(_mdl_KRS_Ejercicios_PerfilesCabecera, mdl_KRS_Ejercicios_PerfilesCabecera_Final, false, false);


                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(KRS_Ejercicios_PerfilesCabecera) +
                                           " SET " +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + "=@idPerfilCabecera," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "=@idEjercicio," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "=@idEmpleado," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "=@codigoCliente," +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.idEmpresa) + "=@idEmpresa" +
                                           " WHERE " +
                                               nameof(KRS_Ejercicios_PerfilesCabecera.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idPerfilCabecera",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idPerfilCabecera),
                        new SqlParameter("@idEjercicio",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEjercicio),
                        new SqlParameter("@idEmpleado",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpleado),
                        new SqlParameter("@codigoCliente",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.codigoCliente),
                        mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa!=null
                            ?   new SqlParameter("@idEmpresa", mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                        new SqlParameter("@id",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.id)
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_Ejercicios_PerfilesCabecera_Final.id;
                }
                else
                {
                    mdl_KRS_Ejercicios_PerfilesCabecera_Final = new KRS_Ejercicios_PerfilesCabecera();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Validado el codigo del cliente, se lo asignamos antes de grabar
                    _mdl_KRS_Ejercicios_PerfilesCabecera.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(_mdl_KRS_Ejercicios_PerfilesCabecera, mdl_KRS_Ejercicios_PerfilesCabecera_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRS_Ejercicios_PerfilesCabecera) +
                                                " (" +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idEjercicio) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idEmpleado) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.codigoCliente) + "," +
                                                        nameof(KRS_Ejercicios_PerfilesCabecera.idEmpresa) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(KRS_Ejercicios_PerfilesCabecera.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idPerfilCabecera," +
                                                    "@idEjercicio," +
                                                    "@idEmpleado," +
                                                    "@codigoCliente," +
                                                    "@idEmpresa" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPerfilCabecera",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idPerfilCabecera),
                        new SqlParameter("@idEjercicio",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEjercicio),
                        new SqlParameter("@idEmpleado",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpleado),
                        new SqlParameter("@codigoCliente",  mdl_KRS_Ejercicios_PerfilesCabecera_Final.codigoCliente),
                        mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa!=null
                            ?   new SqlParameter("@idEmpresa", mdl_KRS_Ejercicios_PerfilesCabecera_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }


                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_Ejercicios_PerfilesCabecera), mdl_KRS_Ejercicios_PerfilesCabecera_DatosViejos, mdl_KRS_Ejercicios_PerfilesCabecera_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera = Obtener_Modelo_Por_Id(_lng_id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);
                //######################################################################################

                if (mdl_KRS_Ejercicios_PerfilesCabecera != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_Ejercicios_PerfilesCabecera) +
                                            " WHERE " +
                                                nameof(KRS_Ejercicios_PerfilesCabecera.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_Ejercicios_PerfilesCabecera), null, mdl_KRS_Ejercicios_PerfilesCabecera, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_KairosProEntities);
                }
                
                //Devolver tambien el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {

                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                KRS_Ejercicios_PerfilesCabecera mdl_KRS_Ejercicios_PerfilesCabecera = Obtener_Modelo_Por_IdPerfilCabecera(_lng_idAuxiliar, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);
                //######################################################################################

                if (mdl_KRS_Ejercicios_PerfilesCabecera != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_Ejercicios_PerfilesCabecera) +
                                            " WHERE " +
                                                nameof(KRS_Ejercicios_PerfilesCabecera.idPerfilCabecera) + "=@idPerfilCabecera";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@idPerfilCabecera", _lng_idAuxiliar)
                    };
                    #endregion

                    //Delete
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                }

                //Devolver tambien el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = (mdl_KRS_Ejercicios_PerfilesCabecera!=null ? mdl_KRS_Ejercicios_PerfilesCabecera.id : -1);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_Ejercicios_PerfilesCabecera_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
